<?php
/**
 * Created by @exife
 * Website: exife.com
 * Email: support@exife.com
 * Name: Special Promotions (Cart Rules)
 */

class ModelSaleSpecialBanners extends Model {

    public function getBanners($data) {
        $sql = "SELECT *, DATE(date_start) date_start, DATE(date_end) date_end FROM " . DB_PREFIX . "sp_banner WHERE 1 = 1";

        if (!empty($data['filter_name'])) {
            $sql .= " AND name LIKE '" . $this->db->escape($data['filter_name']) . "%'";
        }

        if (!empty($data['filter_date_start'])) {
            $sql .= " AND DATE(date_start) = DATE('" . $this->db->escape($data['filter_date_start']) . "')";
        }

        if (!empty($data['filter_date_end'])) {
            $sql .= " AND DATE(date_end) = DATE('" . $this->db->escape($data['filter_date_end']) . "')";
        }

        if (isset($data['filter_status'])) {
            $sql .= " AND status = '" . (int)$data['filter_status'] . "'";
        }

        if (isset($data['filter_sort_order'])) {
            $sql .= " AND sort_order = '" . (int)$data['filter_sort_order'] . "'";
        }

        $sql .= " GROUP BY banner_id";

        $sort_data = array(
            'name',
            'date_start',
            'date_end',
            'status',
            'sort_order'
        );

        if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
            $sql .= " ORDER BY " . $data['sort'];
        } else {
            $sql .= " ORDER BY name";
        }

        if (isset($data['order']) && ($data['order'] == 'DESC')) {
            $sql .= " DESC";
        } else {
            $sql .= " ASC";
        }

        if (isset($data['start']) || isset($data['limit'])) {
            if ($data['start'] < 0) {
                $data['start'] = 0;
            }

            if ($data['limit'] < 1) {
                $data['limit'] = 20;
            }

            $sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
        }

        $query = $this->db->query($sql);

        return $query->rows;
    }

    public function getTotalBanners($data) {
        $sql = "SELECT COUNT(DISTINCT banner_id) AS total FROM " . DB_PREFIX . "sp_banner WHERE 1 = 1";

        if (!empty($data['filter_name'])) {
            $sql .= " AND name LIKE '" . $this->db->escape($data['filter_name']) . "%'";
        }

        if (!empty($data['filter_date_start'])) {
            $sql .= " AND DATE(date_start) = DATE('" . $this->db->escape($data['filter_date_start']) . "')";
        }

        if (!empty($data['filter_date_end'])) {
            $sql .= " AND DATE(date_end) = DATE('" . $this->db->escape($data['filter_date_end']) . "')";
        }

        if (isset($data['filter_status'])) {
            $sql .= " AND status = '" . (int)$data['filter_status'] . "'";
        }

        if (isset($data['filter_sort_order'])) {
            $sql .= " AND sort_order = '" . (int)$data['filter_sort_order'] . "'";
        }

        $query = $this->db->query($sql);

        return $query->row['total'];
    }

    public function addBanner($data) {

        $this->db->query("
            INSERT INTO
                " . DB_PREFIX . "sp_banner
            SET
                `name` = '" . $this->db->escape($data['name']) . "',
                `status` = '" . (int)$data['status'] . "',
                `date_start` = '" . $this->db->escape($data['date_start']) . "',
                `date_end` = '" . $this->db->escape($data['date_end']) . "',
                `sort_order` = '" . (int)$data['sort_order'] . "',
                `banner_type` = '" . (int)$data['banner_type'] . "',
                `cycle_timeout` = '" . (int)$data['cycle_timeout'] . "',
                `modal_timeout` = '" . (int)$data['modal_timeout'] . "',
                `skip_special` = '" . (int)$data['skip_special'] . "',
                `rule` = '" . $this->db->escape(serialize($data['rule'])) . "',
                `positions` = '" . (empty($data['position']) ? '' : $this->db->escape(serialize($data['position']))) . "',
                `banners` = '" . (empty($data['banner']) ? '' : $this->db->escape(serialize($data['banner']))) . "',
                `rule_manufacturers` = '" . (empty($data['rule_manufacturer']) ? '' : $this->db->escape(serialize($data['rule_manufacturer']))) . "',
                `rule_categories` = '" . (empty($data['rule_category']) ? '' : $this->db->escape(serialize($data['rule_category']))) . "',
                `rule_products` = '" . (empty($data['rule_product']) ? '' : $this->db->escape(serialize($data['rule_product']))) . "',
                `cart_products` = '" . (empty($data['cart_product']) ? '' : $this->db->escape(serialize($data['cart_product']))) . "',
                `logged` = '" . (int)$data['logged'] . "',
                `store` = '" . (empty($data['store_ids']) ? '' : $this->db->escape(serialize($data['store_ids']))) . "',
                `customer_group` = '" . (empty($data['customer_group_ids']) ? '' : $this->db->escape(serialize($data['customer_group_ids']))) . "'"
        );

        $banner_id = (int)$this->db->getLastId();

        $this->cache->delete('sp_banner.' . $banner_id);
        $this->cache->delete('sp_banners');

        return $banner_id;
    }

    public function editBanner($banner_id, $data) {

        $this->db->query("
            UPDATE
                " . DB_PREFIX . "sp_banner
            SET
                `name` = '" . $this->db->escape($data['name']) . "',
                `status` = '" . (int)$data['status'] . "',
                `date_start` = '" . $this->db->escape($data['date_start']) . "',
                `date_end` = '" . $this->db->escape($data['date_end']) . "',
                `sort_order` = '" . (int)$data['sort_order'] . "',
                `banner_type` = '" . (int)$data['banner_type'] . "',
                `cycle_timeout` = '" . (int)$data['cycle_timeout'] . "',
                `modal_timeout` = '" . (int)$data['modal_timeout'] . "',
                `skip_special` = '" . (int)$data['skip_special'] . "',
                `rule` = '" . $this->db->escape(serialize($data['rule'])) . "',
                `positions` = '" . (empty($data['position']) ? '' : $this->db->escape(serialize($data['position']))) . "',
                `banners` = '" . (empty($data['banner']) ? '' : $this->db->escape(serialize($data['banner']))) . "',
                `rule_manufacturers` = '" . (empty($data['rule_manufacturer']) ? '' : $this->db->escape(serialize($data['rule_manufacturer']))) . "',
                `rule_categories` = '" . (empty($data['rule_category']) ? '' : $this->db->escape(serialize($data['rule_category']))) . "',
                `rule_products` = '" . (empty($data['rule_product']) ? '' : $this->db->escape(serialize($data['rule_product']))) . "',
                `cart_products` = '" . (empty($data['cart_product']) ? '' : $this->db->escape(serialize($data['cart_product']))) . "',
                `logged` = '" . (int)$data['logged'] . "',
                `store` = '" . (empty($data['store_ids']) ? '' : $this->db->escape(serialize($data['store_ids']))) . "',
                `customer_group` = '" . (empty($data['customer_group_ids']) ? '' : $this->db->escape(serialize($data['customer_group_ids']))) . "'
            WHERE banner_id = '" . (int)$banner_id . "'"
        );

        $this->cache->delete('sp_banner.' . (int)$banner_id);
        $this->cache->delete('sp_banners');
    }

    public function deleteBanner($banner_id) {
        $this->db->query("DELETE FROM " . DB_PREFIX . "sp_banner WHERE banner_id = '" . (int)$banner_id . "'");

        $this->cache->delete('sp_banner.' . (int)$banner_id);
        $this->cache->delete('sp_banners');
    }

    public function statusBanner($banner_id) {
        $this->db->query("
            UPDATE
                " . DB_PREFIX . "sp_banner
            SET
                `status` = 1 - `status`
             WHERE banner_id = '" . (int)$banner_id . "'"
        );

        $this->cache->delete('sp_banner.' . (int)$banner_id);
        $this->cache->delete('sp_banners');
    }

    public function copyBanner($banner_id) {
        $this->db->query("
            INSERT INTO
                " . DB_PREFIX . "sp_banner (
                    `name`,
                    `date_start`,
                    `date_end`,
                    `sort_order`,
                    `banner_type`,
                    `cycle_timeout`,
                    `modal_timeout`,
                    `skip_special`,
                    `rule`,
                    `positions`,
                    `banners`,
                    `rule_manufacturers`,
                    `rule_categories`,
                    `rule_products`,
                    `cart_products`,
                    `logged`,
                    `store`,
                    `customer_group`
                ) SELECT
                    `name`,
                    `date_start`,
                    `date_end`,
                    `sort_order`,
                    `banner_type`,
                    `cycle_timeout`,
                    `modal_timeout`,
                    `skip_special`,
                    `rule`,
                    `positions`,
                    `banners`,
                    `rule_manufacturers`,
                    `rule_categories`,
                    `rule_products`,
                    `cart_products`,
                    `logged`,
                    `store`,
                    `customer_group`
                FROM " . DB_PREFIX . "sp_banner WHERE `banner_id` = '" . (int)$banner_id . "'");
    }

    public function getBanner($banner_id) {
        $query = $this->db->query("SELECT *, DATE(date_start) date_start, DATE(date_end) date_end FROM " . DB_PREFIX . "sp_banner WHERE banner_id = '" . (int)$banner_id . "'");

        if ($query->row) {
            $query->row['store_ids'] = $query->row['store'] ? unserialize($query->row['store']) : array();
            $query->row['customer_group_ids'] = $query->row['customer_group'] ? unserialize($query->row['customer_group']) : array();

            $query->row['rule'] = $query->row['rule'] ? unserialize($query->row['rule']) : array();
            $query->row['positions'] = $query->row['positions'] ? unserialize($query->row['positions']) : array();

            $query->row['banners'] = $query->row['banners'] ? unserialize($query->row['banners']) : array();

            $this->load->model('catalog/product');
            $this->load->model('catalog/category');
            $this->load->model('catalog/manufacturer');

            foreach ($query->row['banners'] as $key => $banner) {
                $products = empty($banner['product']) ? array() : $banner['product'];
                $banner['product'] = array();

                foreach ($products as $product_id) {
                    $product_info = $this->model_catalog_product->getProduct($product_id);

                    if ($product_info) {
                        $banner['product'][] = array(
                            'product_id' => $product_info['product_id'],
                            'name' => strip_tags(html_entity_decode($product_info['name'], ENT_QUOTES, 'UTF-8'))
                        );
                    }
                }

                $query->row['banners'][$key] = $banner;
            }

            $cart_products = $query->row['cart_products'] ? unserialize($query->row['cart_products']) : array();

            $query->row['cart_products'] = array();

            foreach ($cart_products as $product_id) {
                $product_info = $this->model_catalog_product->getProduct($product_id);

                if ($product_info) {
                    $query->row['cart_products'][] = array(
                        'product_id' => $product_info['product_id'],
                        'name' => strip_tags(html_entity_decode($product_info['name'], ENT_QUOTES, 'UTF-8'))
                    );
                }
            }

            $rule_products = $query->row['rule_products'] ? unserialize($query->row['rule_products']) : array();

            $query->row['rule_products'] = array();

            foreach ($rule_products as $product_id) {
                $product_info = $this->model_catalog_product->getProduct($product_id);

                if ($product_info) {
                    $query->row['rule_products'][] = array(
                        'product_id' => $product_info['product_id'],
                        'name' => strip_tags(html_entity_decode($product_info['name'], ENT_QUOTES, 'UTF-8'))
                    );
                }
            }

            if (version_compare(VERSION, '1.5.5.1') >= 0) {
                $rule_categories = $query->row['rule_categories'] ? unserialize($query->row['rule_categories']) : array();

                $query->row['rule_categories'] = array();

                foreach ($rule_categories as $category_id) {
                    $category_info = $this->model_catalog_category->getCategory($category_id);

                    if ($category_info) {
                        $query->row['rule_categories'][] = array(
                            'category_id' => $category_info['category_id'],
                            'name' => strip_tags(html_entity_decode(($category_info['path'] ? $category_info['path'] . ' &gt; ' . $category_info['name'] : $category_info['name']), ENT_QUOTES, 'UTF-8'))
                        );
                    }
                }
            } else {
                $query->row['rule_categories'] = $query->row['rule_categories'] ? unserialize($query->row['rule_categories']) : array();
            }

            if (version_compare(VERSION, '1.5.5.1') >= 0) {
                $rule_manufacturers = $query->row['rule_manufacturers'] ? unserialize($query->row['rule_manufacturers']) : array();

                $query->row['rule_manufacturers'] = array();

                foreach ($rule_manufacturers as $manufacturer_id) {
                    $manufacturer_info = $this->model_catalog_manufacturer->getManufacturer($manufacturer_id);

                    if ($manufacturer_info) {
                        $query->row['rule_manufacturers'][] = array(
                            'manufacturer_id' => $manufacturer_info['manufacturer_id'],
                            'name' => $manufacturer_info['name']
                        );
                    }
                }
            } else {
                $query->row['rule_manufacturers'] = $query->row['rule_manufacturers'] ? unserialize($query->row['rule_manufacturers']) : array();
            }
        }

        return $query->row;
    }

    public function editSettingValue($group = '', $key = '', $value = '', $store_id = 0) {
        $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "setting WHERE store_id = '" . (int)$store_id . "' AND `group` = '" . $this->db->escape($group) . "' AND `key` = '" . $this->db->escape($key) . "'");
        $setting_info = $query->row;

        if (version_compare(VERSION, '1.5.1') >= 0) {
            $serialized = ", serialized = '%s'";
        } else {
            $serialized = '';
        }

        if ($setting_info) {
            if (!is_array($value)) {
                $this->db->query("UPDATE " . DB_PREFIX . "setting SET `value` = '" . $this->db->escape($value) . "'" . ($serialized ? sprintf($serialized, 0) : '') . " WHERE `group` = '" . $this->db->escape($group) . "' AND `key` = '" . $this->db->escape($key) . "' AND store_id = '" . (int)$store_id . "'");
            } else {
                $this->db->query("UPDATE " . DB_PREFIX . "setting SET `value` = '" . $this->db->escape(serialize($value)) . "'" . ($serialized ? sprintf($serialized, 1) : '') . " WHERE `group` = '" . $this->db->escape($group) . "' AND `key` = '" . $this->db->escape($key) . "' AND store_id = '" . (int)$store_id . "'");
            }
        } else {
            if (!is_array($value)) {
                $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '" . (int)$store_id . "', `group` = '" . $this->db->escape($group) . "', `key` = '" . $this->db->escape($key) . "', `value` = '" . $this->db->escape($value) . "'");
            } else {
                $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '" . (int)$store_id . "', `group` = '" . $this->db->escape($group) . "', `key` = '" . $this->db->escape($key) . "', `value` = '" . $this->db->escape(serialize($value)) . "'" . ($serialized ? sprintf($serialized, 1) : '') . "");
            }
        }
    }

    public function getSettingValue($group, $key, $store_id = 0) {
        $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "setting WHERE store_id = '" . (int)$store_id . "' AND `group` = '" . $this->db->escape($group) . "' AND `key` = '" . $this->db->escape($key) . "'");

        if ($query->row) {
            if (empty($query->row['serialized'])) {
                return $query->row['value'];
            } else {
                return unserialize($query->row['value']);
            }
        } else {
            return false;
        }
    }

    public function deleteSettingValue($group, $key, $store_id = 0) {
        $this->db->query("DELETE FROM " . DB_PREFIX . "setting WHERE store_id = '" . (int)$store_id . "' AND `group` = '" . $this->db->escape($group) . "' AND `key` = '" . $this->db->escape($key) . "'");
    }

    public function arrayRule($rule) {
        if (!empty($rule['conditions'])) {
            $_rule = array();
            foreach ($rule['conditions'] as $positions => $item) {
                $pos = explode('--', $positions);
                $this->putIntoRule($_rule, $pos, $item);
            }
            $rule['conditions'] = $_rule;
        } else {
            $rule['conditions'] = array();
        }

        if (!empty($rule['actions'])) {
            $_rule = array();
            foreach ($rule['actions'] as $positions => $item) {
                $pos = explode('--', $positions);
                $this->putIntoRule($_rule, $pos, $item);
            }
            $rule['actions'] = $_rule;
        } else {
            $rule['actions'] = array();
        }

        return $rule;
    }

    private function putIntoRule(&$rule, $pos, $item) {
        $index = array_shift($pos) - 1;
        if (!count($pos)) {
            $rule[$index] = $item;
        } else {
            if (!isset($rule[$index]['rules'])) {
                $rule[$index]['rules'] = array();
            }
            $this->putIntoRule($rule[$index]['rules'], $pos, $item);
        }
    }
}