<?php
/**
 * Created by @exife
 * Website: exife.com
 * Email: support@exife.com
 * Name: Special Promotions (Cart Rules)
 */
?>
<?php echo $header; ?>
<div id="content">
    <div class="breadcrumb">
        <?php foreach ($breadcrumbs as $breadcrumb) { ?>
            <?php echo $breadcrumb['separator']; ?><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a>
        <?php } ?>
    </div>
    <?php if ($error_warning) { ?>
    <div class="warning"><?php echo $error_warning; ?></div>
    <?php } ?>
    <div class="box">
        <div class="heading">
            <h1><img src="view/image/order.png" alt="" /> <?php echo $heading_title; ?></h1>
            <div class="buttons"><a onclick="$('#form').submit();" class="button"><span><?php echo $button_save; ?></span></a><a href="<?php echo $cancel; ?>" class="button"><span><?php echo $button_cancel; ?></span></a></div>
        </div>
        <div class="content">
            <div class="main-vtabs vtabs">
                <a href="#tab-main"><?php echo $tab_main; ?></a>
                <a href="#tab-position-content"><?php echo $tab_position_content; ?></a>
                <a href="#tab-page-conditions"><?php echo $tab_page_conditions; ?></a>
                <a href="#tab-cart-conditions"><?php echo $tab_cart_conditions; ?></a>
            </div>
            <form action="<?php echo $action; ?>" method="post" enctype="multipart/form-data" id="form">
                <div id="tab-main" class="vtabs-content">
                    <h2><?php echo $text_general_information; ?></h2>
                    <table class="form">
                        <tr>
                            <td><span class="required">*</span> <?php echo $entry_name; ?></td>
                            <td>
                                <input type="text" name="name" value="<?php echo $name; ?>" size="100" />
                                <?php if (!empty($error_name)) { ?>
                                    <span class="error"><?php echo $error_name; ?></span><br />
                                <?php } ?>
                            </td>
                        </tr>
                        <tr>
                            <td><span class="required">*</span> <?php echo $entry_status; ?></td>
                            <td>
                                <?php if($status) {
                                    $checked1 = ' checked="checked"';
                                    $checked0 = '';
                                } else {
                                    $checked1 = '';
                                    $checked0 = ' checked="checked"';
                                } ?>
                                <label for="status_1">
                                    <?php echo $text_enabled; ?>
                                    <input type="radio"<?php echo $checked1; ?> id="status_1" name="status" value="1" />
                                </label>
                                <label for="status_0">
                                    <?php echo $text_disabled; ?>
                                    <input type="radio"<?php echo $checked0; ?> id="status_0" name="status" value="0" />
                                </label>
                            </td>
                        </tr>
                        <tr>
                            <td><span class="required">*</span> <?php echo $entry_store; ?></td>
                            <td>
                                <div class="scrollbox">
                                    <?php $class = 'even'; ?>
                                    <div class="<?php echo $class; ?>">
                                        <?php if (in_array(0, $store_ids)) { ?>
                                            <label>
                                                <input type="checkbox" name="store_ids[]" value="0" checked="checked" />
                                                <?php echo $text_default; ?>
                                            </label>
                                        <?php } else { ?>
                                            <label>
                                                <input type="checkbox" name="store_ids[]" value="0" />
                                                <?php echo $text_default; ?>
                                            </label>
                                        <?php } ?>
                                    </div>
                                    <?php foreach ($stores as $store) { ?>
                                        <?php $class = ($class == 'even' ? 'odd' : 'even'); ?>
                                        <div class="<?php echo $class; ?>">
                                            <?php if (in_array($store['store_id'], $store_ids)) { ?>
                                                <label>
                                                    <input type="checkbox" name="store_ids[]" value="<?php echo $store['store_id']; ?>" checked="checked" />
                                                    <?php echo $store['name']; ?>
                                                </label>
                                            <?php } else { ?>
                                                <label>
                                                    <input type="checkbox" name="store_ids[]" value="<?php echo $store['store_id']; ?>" />
                                                    <?php echo $store['name']; ?>
                                                </label>
                                            <?php } ?>
                                        </div>
                                    <?php } ?>
                                </div>
                                <?php if (!empty($error_store)) { ?>
                                    <span class="error"><?php echo $error_store; ?></span><br />
                                <?php } ?>
                            </td>
                        </tr>
                        <tr>
                            <td><span class="required">*</span> <?php echo $entry_customer_group; ?></td>
                            <td>
                                <div class="scrollbox">
                                    <?php $class = 'odd'; ?>
                                    <?php foreach ($customer_groups as $customer_group) { ?>
                                        <?php $class = ($class == 'even' ? 'odd' : 'even'); ?>
                                        <div class="<?php echo $class; ?>">
                                            <?php if (in_array($customer_group['customer_group_id'], $customer_group_ids)) { ?>
                                                <label>
                                                    <input type="checkbox" name="customer_group_ids[]" value="<?php echo $customer_group['customer_group_id']; ?>" checked="checked" />
                                                    <?php echo $customer_group['name']; ?>
                                                </label>
                                            <?php } else { ?>
                                                <label>
                                                    <input type="checkbox" name="customer_group_ids[]" value="<?php echo $customer_group['customer_group_id']; ?>" />
                                                    <?php echo $customer_group['name']; ?>
                                                </label>
                                            <?php } ?>
                                        </div>
                                    <?php } ?>
                                </div>
                                <?php if (!empty($error_customer_group)) { ?>
                                    <span class="error"><?php echo $error_customer_group; ?></span><br />
                                <?php } ?>
                            </td>
                        </tr>
                        <tr>
                            <td><?php echo $entry_logged; ?></td>
                            <td>
                                <?php if ($logged) { ?>
                                    <label>
                                        <?php echo $text_yes; ?>
                                        <input type="radio" name="logged" value="1" checked="checked" />
                                    </label>
                                    <label>
                                        <?php echo $text_no; ?>
                                        <input type="radio" name="logged" value="0" />
                                    </label>
                                <?php } else { ?>
                                    <label>
                                        <?php echo $text_yes; ?>
                                        <input type="radio" name="logged" value="1" />
                                    </label>
                                    <label>
                                        <?php echo $text_no; ?>
                                        <input type="radio" name="logged" value="0" checked="checked" />
                                    </label>
                                <?php } ?>
                            </td>
                        </tr>
                        <tr>
                            <td><?php echo $entry_date_start; ?></td>
                            <td>
                                <input type="text" name="date_start" value="<?php echo $date_start == '0000-00-00' ? '' : $date_start; ?>" class="date" />
                            </td>
                        </tr>
                        <tr>
                            <td><?php echo $entry_date_end; ?></td>
                            <td>
                                <input type="text" name="date_end" value="<?php echo $date_end == '0000-00-00' ? '' : $date_end; ?>" class="date" />
                            </td>
                        </tr>
                        <tr>
                            <td><?php echo $entry_sort_order; ?></td>
                            <td>
                                <input type="text" name="sort_order" value="<?php echo $sort_order; ?>" size="4" />
                            </td>
                        </tr>
                    </table>
                </div>
                <div id="tab-position-content" class="vtabs-content">
                    <h2><?php echo $text_banner_position; ?></h2>
                    <table id="position" class="list">
                        <thead>
                            <tr>
                                <td class="left"><?php echo $entry_layout; ?></td>
                                <td class="left"><?php echo $entry_position; ?></td>
                                <td class="left"><?php echo $entry_status; ?></td>
                                <td class="right"><?php echo $entry_sort_order; ?></td>
                                <td></td>
                            </tr>
                        </thead>
                        <?php $position_row = 0; ?>
                        <?php foreach ($positions as $position) { ?>
                            <tbody id="position-row<?php echo $position_row; ?>">
                                <tr>
                                    <td class="left">
                                        <select name="position[<?php echo $position_row; ?>][layout_id]">
                                            <?php foreach ($layouts as $layout) { ?>
                                                <?php if ($layout['layout_id'] == $position['layout_id']) { ?>
                                                    <option value="<?php echo $layout['layout_id']; ?>" selected="selected"><?php echo $layout['name']; ?></option>
                                                <?php } else { ?>
                                                    <option value="<?php echo $layout['layout_id']; ?>"><?php echo $layout['name']; ?></option>
                                                <?php } ?>
                                            <?php } ?>
                                        </select>
                                    </td>
                                    <td class="left">
                                        <select name="position[<?php echo $position_row; ?>][position]">
                                            <?php if ($position['position'] == 'content_top') { ?>
                                                <option value="content_top" selected="selected"><?php echo $text_content_top; ?></option>
                                            <?php } else { ?>
                                                <option value="content_top"><?php echo $text_content_top; ?></option>
                                            <?php } ?>
                                            <?php if ($position['position'] == 'content_bottom') { ?>
                                                <option value="content_bottom" selected="selected"><?php echo $text_content_bottom; ?></option>
                                            <?php } else { ?>
                                                <option value="content_bottom"><?php echo $text_content_bottom; ?></option>
                                            <?php } ?>
                                            <?php if ($position['position'] == 'column_left') { ?>
                                                    <option value="column_left" selected="selected"><?php echo $text_column_left; ?></option>
                                            <?php } else { ?>
                                                    <option value="column_left"><?php echo $text_column_left; ?></option>
                                            <?php } ?>
                                            <?php if ($position['position'] == 'column_right') { ?>
                                                    <option value="column_right" selected="selected"><?php echo $text_column_right; ?></option>
                                            <?php } else { ?>
                                                    <option value="column_right"><?php echo $text_column_right; ?></option>
                                            <?php } ?>
                                        </select>
                                    </td>
                                    <td class="left">
                                        <select name="position[<?php echo $position_row; ?>][status]">
                                            <?php if ($position['status']) { ?>
                                                <option value="1" selected="selected"><?php echo $text_enabled; ?></option>
                                                <option value="0"><?php echo $text_disabled; ?></option>
                                            <?php } else { ?>
                                                <option value="1"><?php echo $text_enabled; ?></option>
                                                <option value="0" selected="selected"><?php echo $text_disabled; ?></option>
                                            <?php } ?>
                                        </select>
                                    </td>
                                    <td class="right">
                                        <input type="text" name="position[<?php echo $position_row; ?>][sort_order]" value="<?php echo $position['sort_order']; ?>" size="3" />
                                    </td>
                                    <td class="left">
                                        <a onclick="$('#position-row<?php echo $position_row; ?>').remove();" class="button"><span><?php echo $button_remove; ?></span></a>
                                    </td>
                                </tr>
                            </tbody>
                            <?php $position_row++; ?>
                        <?php } ?>
                        <tfoot>
                            <tr>
                                <td colspan="4"></td>
                                <td class="left">
                                    <a onclick="addPosition();" class="button"><span><?php echo $button_add_position; ?></span></a>
                                </td>
                            </tr>
                        </tfoot>
                    </table>
                    <h2><?php echo $text_banner_content; ?></h2>
                    <table class="form">
                        <tr>
                            <td><?php echo $entry_banner_type; ?></td>
                            <td>
                                <select name="banner_type">
                                    <?php if ($banner_type == 0) { ?>
                                        <option value="0" selected="selected"><?php echo $text_content_block; ?></option>
                                        <option value="1"><?php echo $text_modal_popup; ?></option>
                                    <?php } else { ?>
                                        <option value="0"><?php echo $text_content_block; ?></option>
                                        <option value="1" selected="selected"><?php echo $text_modal_popup; ?></option>
                                    <?php } ?>
                                </select>
                            </td>
                        </tr>
                        <tbody class="content-block">
                            <tr>
                                <td><?php echo $entry_content_cycle_timeout; ?></td>
                                <td>
                                    <input type="text" name="cycle_timeout" value="<?php echo $cycle_timeout; ?>" size="3" />
                                </td>
                            </tr>
                        </tbody>
                        <tbody class="modal-popup" style="display:none;">
                            <tr>
                                <td><?php echo $entry_content_modal_timeout; ?></td>
                                <td>
                                    <input type="text" name="modal_timeout" value="<?php echo $modal_timeout; ?>" size="3" />
                                </td>
                            </tr>
                        </tbody>
                    </table>
                    <div class="banner-vtabs vtabs content-block">
                        <?php $banner_row = 1; ?>
                        <?php foreach ($banners as $banner) { ?>
                            <a href="#tab-banner-<?php echo $banner_row; ?>" id="banner-<?php echo $banner_row; ?>"><?php echo $tab_banner . ' ' . $banner_row; ?>&nbsp;<img src="view/image/delete.png" alt="" onclick="$('.banner-vtabs a:first').trigger('click'); $('#banner-<?php echo $banner_row; ?>').remove(); $('#tab-banner-<?php echo $banner_row; ?>').remove(); return false;" /></a>
                            <?php $banner_row++; ?>
                        <?php } ?>
                        <span id="banner-add"><?php echo $button_add_banner; ?>&nbsp;<img src="view/image/add.png" alt="" onclick="addBanner();" /></span>
                    </div>
                    <?php $banner_row = 1; ?>
                    <?php foreach ($banners as $banner) { ?>
                        <div id="tab-banner-<?php echo $banner_row; ?>" class="vtabs-content content-block-margin">
                            <div id="language-<?php echo $banner_row; ?>" class="htabs">
                                <?php foreach ($languages as $language) { ?>
                                    <a href="#tab-language-<?php echo $banner_row; ?>-<?php echo $language['language_id']; ?>"><img src="view/image/flags/<?php echo $language['image']; ?>" title="<?php echo $language['name']; ?>" /> <?php echo $language['name']; ?></a>
                                <?php } ?>
                            </div>
                            <?php foreach ($languages as $language) { ?>
                                <div id="tab-language-<?php echo $banner_row; ?>-<?php echo $language['language_id']; ?>">
                                    <table class="form">
                                        <tr>
                                            <td><?php echo $entry_heading_text; ?></td>
                                            <td>
                                                <input type="text" name="banner[<?php echo $banner_row; ?>][heading_text][<?php echo $language['language_id']; ?>]" value="<?php echo isset($banner['heading_text'][$language['language_id']]) ? $banner['heading_text'][$language['language_id']] : ''; ?>" size="100" />
                                            </td>
                                        </tr>
                                        <tr>
                                            <td><?php echo $entry_content; ?></td>
                                            <td><textarea name="banner[<?php echo $banner_row; ?>][content][<?php echo $language['language_id']; ?>]" id="content-<?php echo $banner_row; ?>-<?php echo $language['language_id']; ?>"><?php echo isset($banner['content'][$language['language_id']]) ? $banner['content'][$language['language_id']] : ''; ?></textarea></td>
                                        </tr>
                                        <tbody class="modal-popup">
                                            <tr>
                                                <td><?php echo $entry_close_button_text; ?></td>
                                                <td>
                                                    <input type="text" name="banner[<?php echo $banner_row; ?>][close_button_text][<?php echo $language['language_id']; ?>]" value="<?php echo isset($banner['close_button_text'][$language['language_id']]) ? $banner['close_button_text'][$language['language_id']] : ''; ?>" size="100" />
                                                </td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </div>
                            <?php } ?>
                            <table class="form">
                                <tr>
                                    <td><?php echo $entry_products_in_banner; ?></td>
                                    <td>
                                        <?php if($banner['products_in_banner']) {
                                            $checked1 = ' checked="checked"';
                                            $checked0 = '';
                                        } else {
                                            $checked1 = '';
                                            $checked0 = ' checked="checked"';
                                        } ?>
                                        <label for="products_in_banner_<?php echo $banner_row; ?>_1">
                                            <?php echo $text_yes; ?>
                                            <input type="radio"<?php echo $checked1; ?> id="products_in_banner_<?php echo $banner_row; ?>_1" name="banner[<?php echo $banner_row; ?>][products_in_banner]" class="banner_<?php echo $banner_row; ?>_products_in_banner" value="1" />
                                        </label>
                                        <label for="products_in_banner_<?php echo $banner_row; ?>_0">
                                            <?php echo $text_no; ?>
                                            <input type="radio"<?php echo $checked0; ?> id="products_in_banner_<?php echo $banner_row; ?>_0" name="banner[<?php echo $banner_row; ?>][products_in_banner]" class="banner_<?php echo $banner_row; ?>_products_in_banner" value="0" />
                                        </label>
                                    </td>
                                </tr>
                                <tbody id="products_in_banner<?php echo $banner_row; ?>">
                                    <tr>
                                        <td><?php echo $entry_products; ?></td>
                                        <td><input type="text" name="products<?php echo $banner_row; ?>" value="" /></td>
                                    </tr>
                                    <tr>
                                        <td>&nbsp;</td>
                                        <td>
                                            <div class="scrollbox" id="product-<?php echo $banner_row; ?>">
                                                <?php $class = 'odd'; ?>
                                                <?php if (!empty($banner['product']) && is_array($banner['product'])) { ?>
                                                    <?php foreach ($banner['product'] as $product) { ?>
                                                        <?php $class = ($class == 'even' ? 'odd' : 'even'); ?>
                                                        <div id="product<?php echo $banner_row; ?>_<?php echo $product['product_id']; ?>" class="<?php echo $class; ?>">
                                                            <?php echo $product['name']; ?><img src="view/image/delete.png" />
                                                            <input type="hidden" name="banner[<?php echo $banner_row; ?>][product][]" value="<?php echo $product['product_id']; ?>" />
                                                        </div>
                                                    <?php } ?>
                                                <?php } ?>
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td><?php echo $entry_image_size; ?></td>
                                        <td>
                                            <input type="text" name="banner[<?php echo $banner_row; ?>][image_width]" value="<?php echo $banner['image_width']; ?>" size="3" /> &times; <input type="text" name="banner[<?php echo $banner_row; ?>][image_height]" value="<?php echo $banner['image_height']; ?>" size="3" />
                                        </td>
                                    </tr>
                                </tbody>
                                <tr>
                                    <td><?php echo $entry_show_boxframe; ?></td>
                                    <td>
                                        <?php if($banner['show_boxframe']) {
                                            $checked1 = ' checked="checked"';
                                            $checked0 = '';
                                        } else {
                                            $checked1 = '';
                                            $checked0 = ' checked="checked"';
                                        } ?>
                                        <label for="show_boxframe_<?php echo $banner_row; ?>_1">
                                            <?php echo $text_yes; ?>
                                            <input type="radio"<?php echo $checked1; ?> id="show_boxframe_<?php echo $banner_row; ?>_1" name="banner[<?php echo $banner_row; ?>][show_boxframe]" value="1" />
                                        </label>
                                        <label for="show_boxframe_<?php echo $banner_row; ?>_0">
                                            <?php echo $text_no; ?>
                                            <input type="radio"<?php echo $checked0; ?> id="show_boxframe_<?php echo $banner_row; ?>_0" name="banner[<?php echo $banner_row; ?>][show_boxframe]" value="0" />
                                        </label>
                                    </td>
                                </tr>
                            </table>
                        </div>
                        <?php $banner_row++; ?>
                    <?php } ?>
                </div>
                <div id="tab-cart-conditions" class="vtabs-content">
                    <h2><?php echo $text_rule_to_cart_products; ?></h2>
                    <table class="form">
                        <tr>
                            <td><?php echo $entry_cart_products; ?></td>
                            <td><input type="text" name="cart_products" value="" /></td>
                        </tr>
                        <tr>
                            <td>&nbsp;</td>
                            <td>
                                <div class="scrollbox" id="cart_product">
                                    <?php $class = 'odd'; ?>
                                    <?php foreach ($cart_products as $cart_product) { ?>
                                        <?php $class = ($class == 'even' ? 'odd' : 'even'); ?>
                                        <div id="cart_product<?php echo $cart_product['product_id']; ?>" class="<?php echo $class; ?>">
                                            <?php echo $cart_product['name']; ?><img src="view/image/delete.png" />
                                            <input type="hidden" name="cart_product[]" value="<?php echo $cart_product['product_id']; ?>" />
                                        </div>
                                    <?php } ?>
                                </div>
                            </td>
                        </tr>
                    </table>
                    <h2><?php echo $text_conditions; ?></h2>
                    <table class="form">
                        <tr>
                            <td>
                                <?php
                                    function conditionsTree($conditions, $scope, $key = '', $product = '') {

                                        if (!$key) {
                                            $out = '<div class="rule">';
                                        } elseif ($key == '1--') {
                                            $out = '<ul class="rules" data-section="conditions">';
                                        } else {
                                            $out = '<ul class="rules">';
                                        }

                                        foreach($conditions as $i => $condition) {
                                            $k = $key . ($i + 1);

                                            if ($key) {
                                                $out .= '<li>';
                                            }

                                            $out .= '<input type="hidden" name="rule[conditions][' . $k . '][type]" value="' . $condition['type'] . '" />';

                                            switch ($condition['type']) {
                                                case 'rule/condition_product_found':
                                                    $out .= sprintf($scope['rule_condition_product_found'], '<span class="data-edit" data-type="select" data-values="found_not_found" data-selected="' . $condition['value'] . '" data-name="rule[conditions][' . $k . '][value]"></span>', '<span class="data-edit" data-type="select" data-values="all_any" data-selected="' . $condition['aggregator'] . '" data-name="rule[conditions][' . $k . '][aggregator]"></span>');
                                                break;
                                                case 'rule/condition_product_subselect':
                                                    $out .= sprintf($scope['rule_condition_product_subselect'], '<span class="data-edit" data-type="select" data-values="total_qty_amount" data-selected="' . $condition['attribute'] . '" data-name="rule[conditions][' . $k . '][attribute]"></span>', '<span class="data-edit" data-type="select" data-values="operators" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '">' . ($condition['value'] >= 0 ? $condition['value'] : '&hellip;') . '</span>', '<span class="data-edit" data-type="select" data-values="all_any" data-selected="' . $condition['aggregator'] . '" data-name="rule[conditions][' . $k . '][aggregator]"></span>');
                                                break;
                                                case 'rule/condition_combine':
                                                    $out .= sprintf($scope['rule_condition_combine'], '<span class="data-edit" data-type="select" data-values="all_any" data-selected="' . $condition['aggregator'] . '" data-name="rule[conditions][' . $k . '][aggregator]"></span>', '<span class="data-edit" data-type="select" data-values="true_false" data-selected="' . $condition['value'] . '" data-name="rule[conditions][' . $k . '][value]"></span>');
                                                break;
                                                case 'rule/condition_cart|base_subtotal':
                                                    $out .= sprintf($scope['rule_condition_cart_base_subtotal'], '<span class="data-edit" data-type="select" data-values="operators" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '">' . ($condition['value'] >= 0 ? $condition['value'] : '&hellip;') . '</span>');
                                                break;
                                                case 'rule/condition_cart|total_qty':
                                                    $out .= sprintf($scope['rule_condition_cart_total_qty'], '<span class="data-edit" data-type="select" data-values="operators" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '">' . ($condition['value'] >= 0 ? $condition['value'] : '&hellip;') . '</span>');
                                                break;
                                                case 'rule/condition_cart|diff_qty':
                                                    $out .= sprintf($scope['rule_condition_cart_diff_qty'], '<span class="data-edit" data-type="select" data-values="operators" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '">' . ($condition['value'] >= 0 ? $condition['value'] : '&hellip;') . '</span>');
                                                break;
                                                case 'rule/condition_cart|weight':
                                                    $out .= sprintf($scope['rule_condition_cart_weight'], '<span class="data-edit" data-type="select" data-values="operators" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '">' . ($condition['value'] >= 0 ? $condition['value'] : '&hellip;') . '</span>');
                                                break;
                                                case 'rule/condition_cart|payment_method':
                                                    $out .= sprintf($scope['rule_condition_cart_payment_method'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="select" data-values="payment_methods" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '"></span>');
                                                break;
                                                case 'rule/condition_cart|shipping_method':
                                                    $out .= sprintf($scope['rule_condition_cart_shipping_method'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="select" data-values="shipping_methods" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '"></span>');
                                                break;
                                                case 'rule/condition_cart|shipping_postcode':
                                                    $out .= sprintf($scope['rule_condition_cart_shipping_postcode'], '<span class="data-edit" data-type="select" data-values="operators" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '">' . ($condition['value'] ? $condition['value'] : '&hellip;') . '</span>');
                                                break;
                                                case 'rule/condition_cart|shipping_zone_id':
                                                    $out .= sprintf($scope['rule_condition_cart_shipping_zone_id'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="select" data-values="zones" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '"></span>');
                                                break;
                                                case 'rule/condition_cart|shipping_country_id':
                                                    $out .= sprintf($scope['rule_condition_cart_shipping_country_id'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="select" data-values="countries" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '"></span>');
                                                break;
                                                case 'rule/condition_customer|store_id':
                                                    $out .= sprintf($scope['rule_condition_customer_store_id'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="select" data-values="stores" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '"></span>');
                                                break;
                                                case 'rule/condition_customer|customer_group_id':
                                                    $out .= sprintf($scope['rule_condition_customer_group_id'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="select" data-values="customer_groups" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '"></span>');
                                                break;
                                                case 'rule/condition_customer|registration_date':
                                                    $out .= sprintf($scope['rule_condition_customer_registration_date'], '<span class="data-edit" data-type="select" data-values="operators" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-class="date" data-selected="' . $condition['value'] . '">' . ($condition['value'] ? $condition['value'] : '&hellip;') . '</span>');
                                                break;
                                                case 'rule/condition_customer|email':
                                                    $out .= sprintf($scope['rule_condition_customer_email'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '">' . ($condition['value'] ? $condition['value'] : '&hellip;') . '</span>');
                                                break;
                                                case 'rule/condition_customer|firstname':
                                                    $out .= sprintf($scope['rule_condition_customer_firstname'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '">' . ($condition['value'] ? $condition['value'] : '&hellip;') . '</span>');
                                                break;
                                                case 'rule/condition_customer|lastname':
                                                    $out .= sprintf($scope['rule_condition_customer_lastname'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '">' . ($condition['value'] ? $condition['value'] : '&hellip;') . '</span>');
                                                break;
                                                case 'rule/condition_orders|order_num':
                                                    $out .= sprintf($scope['rule_condition_orders_order_num'], '<span class="data-edit" data-type="select" data-values="operators" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '">' . ($condition['value'] >= 0 ? $condition['value'] : '&hellip;') . '</span>');
                                                break;
                                                case 'rule/condition_orders|sales_amount':
                                                    $out .= sprintf($scope['rule_condition_orders_sales_amount'], '<span class="data-edit" data-type="select" data-values="operators" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '">' . ($condition['value'] >= 0 ? $condition['value'] : '&hellip;') . '</span>');
                                                break;
                                                case 'rule/condition_orders|day_of_week':
                                                    $out .= sprintf($scope['rule_condition_day_of_week'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="select" data-values="weekdays" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '"></span>');
                                                break;
                                                case 'rule/condition_orders|time':
                                                    $out .= sprintf($scope['rule_condition_time'], '<span class="data-edit" data-type="select" data-values="operators" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-class="time" data-selected="' . $condition['value'] . '">' . ($condition['value'] ? $condition['value'] : '&hellip;') . '</span>');
                                                break;
                                                case 'rule/condition_cart_product|price':
                                                    $out .= sprintf($scope['rule_condition_cart_product_price'], '<span class="data-edit" data-type="select" data-values="operators" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '">' . ($condition['value'] >= 0 ? $condition['value'] : '&hellip;') . '</span>');
                                                break;
                                                case 'rule/condition_cart_product|qty':
                                                    $out .= sprintf($scope['rule_condition_cart_product_qty'], '<span class="data-edit" data-type="select" data-values="operators" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '">' . ($condition['value'] >= 0 ? $condition['value'] : '&hellip;') . '</span>');
                                                break;
                                                case 'rule/condition_cart_product|total':
                                                    $out .= sprintf($scope['rule_condition_cart_product_total'], '<span class="data-edit" data-type="select" data-values="operators" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '">' . ($condition['value'] >= 0 ? $condition['value'] : '&hellip;') . '</span>');
                                                break;
                                                case 'rule/condition_cart_product|manufacturer_id':
                                                    $out .= sprintf($scope['rule_condition_manufacturer_id'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="select" data-values="manufacturers" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '"></span>');
                                                break;
                                                case 'rule/condition_cart_product|category_id':
                                                    $out .= sprintf($scope['rule_condition_category_id'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="select" data-values="categories" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '"></span>');
                                                break;
                                                case 'rule/condition_cart_product|price_type':
                                                    $out .= sprintf($scope['rule_condition_price_type'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="select" data-values="price_types" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '"></span>');
                                                break;
                                                case 'rule/condition_cart_product|model':
                                                    $out .= sprintf($scope['rule_condition_model'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '">' . ($condition['value'] ? $condition['value'] : '&hellip;') . '</span>');
                                                break;
                                            }

                                            if (strpos($condition['type'], 'rule/condition_cart_product|attribute_') === 0) {
                                                $out .= $scope['values_product_conditions'][$condition['type']] . ' <span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span> <span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '">' . ($condition['value'] ? $condition['value'] : '&hellip;') . '</span>';
                                            }

                                            if (strpos($condition['type'], 'rule/condition_cart_product|option_') === 0) {
                                                $out .= $scope['values_product_conditions'][$condition['type']] . ' <span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $condition['operator'] . '" data-name="rule[conditions][' . $k . '][operator]"></span> ';
                                                if (substr($condition['type'], -strlen('select')) === 'select' || substr($condition['type'], -strlen('radio')) === 'radio' || substr($condition['type'], -strlen('checkbox')) === 'checkbox' || substr($condition['type'], -strlen('image')) === 'image') {
                                                    $arr = explode('|', str_replace('rule/condition_cart_product|option_', '', $condition['type']));
                                                    $out .= '<span class="data-edit" data-type="select" data-values="options_values_' . array_shift($arr) . '" data-selected="' . $condition['value'] . '" data-name="rule[conditions][' . $k . '][value]"></span>';
                                                } elseif (substr($condition['type'], -strlen('text')) === 'text') {
                                                    $out .= '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-selected="' . $condition['value'] . '">' . ($condition['value'] ? $condition['value'] : '&hellip;') . '</span>';
                                                } elseif (substr($condition['type'], -strlen('textarea')) === 'textarea') {
                                                    $out .= '<span class="data-edit" data-type="textarea" data-name="rule[conditions][' . $k . '][value]">' . ($condition['value'] ? $condition['value'] : '&hellip;') . '</span>';
                                                } elseif (substr($condition['type'], -strlen('datetime')) === 'datetime') {
                                                    $out .= '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-class="datetime" data-selected="' . $condition['value'] . '">' . ($condition['value'] ? $condition['value'] : '&hellip;') . '</span>';
                                                } elseif (substr($condition['type'], -strlen('date')) === 'date') {
                                                    $out .= '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-class="date" data-selected="' . $condition['value'] . '">' . ($condition['value'] ? $condition['value'] : '&hellip;') . '</span>';
                                                } elseif (substr($condition['type'], -strlen('time')) === 'time') {
                                                    $out .= '<span class="data-edit" data-type="text" data-name="rule[conditions][' . $k . '][value]" data-class="time" data-selected="' . $condition['value'] . '">' . ($condition['value'] ? $condition['value'] : '&hellip;') . '</span>';
                                                }
                                            }

                                            if (!$key) {
                                                $out .= '</div>';
                                            } else {
                                                $out .= '<img class="remove-rule" src="view/image/delete.png" alt="" valign="middle" />';
                                            }

                                            if (!empty($condition['rules'])) {
                                                $out .= conditionsTree($condition['rules'], $scope, $k . '--', (($product || $condition['type'] == 'rule/condition_product_found' || $condition['type'] == 'rule/condition_product_subselect') ? '1' : ''));
                                            } elseif (!$key) {
                                                $out .= '<ul class="rules" data-section="conditions">';
                                                $out .= '<li><span class="data-edit" data-rule="new" data-type="select" data-values="' . (($product || $condition['type'] == 'rule/condition_product_found' || $condition['type'] == 'rule/condition_product_subselect') ? 'product_conditions' : 'conditions') . '"><img class="add-rule" src="view/image/add.png" alt="" valign="middle" /></span></li>';
                                                $out .= '</ul>';
                                            }

                                            if ($key) {
                                                $out.= '</li>';
                                            }
                                        }

                                        if ($key) {
                                            $out .= '<li><span class="data-edit" data-rule="new" data-type="select" data-values="' . ($product ? 'product_conditions' : 'conditions') . '"><img class="add-rule" src="view/image/add.png" alt="" valign="middle" /></span></li>';

                                            $out .= '</ul>';
                                        }

                                        return $out;
                                    }

                                    if (empty($rule['conditions'])) {
                                        $rule['conditions'] = array(array('type' => 'rule/condition_combine', 'aggregator' => 'all', 'value' => '1'));
                                    }

                                    echo conditionsTree($rule['conditions'], $this->data);
                                ?>
                            </td>
                        </tr>
                    </table>
                </div>
                <div id="tab-page-conditions" class="vtabs-content">
                    <h2><?php echo $text_rule_to_products; ?></h2>
                    <span class="help"><?php echo $text_rule_to_product_help; ?></span><br/>
                    <table class="form">
                        <tr>
                            <td><?php echo $entry_products; ?></td>
                            <td><input type="text" name="rule_products" value="" /></td>
                        </tr>
                        <tr>
                            <td>&nbsp;</td>
                            <td>
                                <div class="scrollbox" id="rule_product">
                                    <?php $class = 'odd'; ?>
                                    <?php foreach ($rule_products as $rule_product) { ?>
                                        <?php $class = ($class == 'even' ? 'odd' : 'even'); ?>
                                        <div id="rule_product<?php echo $rule_product['product_id']; ?>" class="<?php echo $class; ?>">
                                            <?php echo $rule_product['name']; ?><img src="view/image/delete.png" />
                                            <input type="hidden" name="rule_product[]" value="<?php echo $rule_product['product_id']; ?>" />
                                        </div>
                                    <?php } ?>
                                </div>
                            </td>
                        </tr>
                    </table>
                    <h2><?php echo $text_rule_to_categories; ?></h2>
                    <span class="help"><?php echo $text_rule_to_category_help; ?></span><br/>
                    <table class="form">
                        <?php if (version_compare(VERSION, '1.5.5.1') >= 0) { ?>
                            <tr>
                                <td><?php echo $entry_categories; ?></td>
                                <td><input type="text" name="rule_categories" value="" /></td>
                            </tr>
                            <tr>
                                <td>&nbsp;</td>
                                <td>
                                    <div class="scrollbox" id="rule_category">
                                        <?php $class = 'odd'; ?>
                                        <?php foreach ($rule_categories as $rule_category) { ?>
                                            <?php $class = ($class == 'even' ? 'odd' : 'even'); ?>
                                            <div id="rule_category<?php echo $rule_category['category_id']; ?>" class="<?php echo $class; ?>">
                                                <?php echo $rule_category['name']; ?><img src="view/image/delete.png" />
                                                <input type="hidden" name="rule_category[]" value="<?php echo $rule_category['category_id']; ?>" />
                                            </div>
                                        <?php } ?>
                                    </div>
                                </td>
                            </tr>
                        <?php } else { ?>
                            <tr>
                                <td><?php echo $entry_categories; ?></td>
                                <td>
                                    <div class="scrollbox">
                                        <?php $class = 'odd'; ?>
                                        <?php foreach ($categories as $category) { ?>
                                            <?php $class = ($class == 'even' ? 'odd' : 'even'); ?>
                                            <div class="<?php echo $class; ?>">
                                                <?php if ($rule_categories && is_array($rule_categories) && in_array($category['category_id'], $rule_categories)) { ?>
                                                    <input type="checkbox" name="rule_category[]" value="<?php echo $category['category_id']; ?>" checked="checked" />
                                                <?php } else { ?>
                                                    <input type="checkbox" name="rule_category[]" value="<?php echo $category['category_id']; ?>" />
                                                <?php } ?>
                                                <?php echo $category['name']; ?>
                                            </div>
                                        <?php } ?>
                                    </div>
                                </td>
                            </tr>
                        <?php } ?>
                    </table>
                    <h2><?php echo $text_rule_to_manufacturers; ?></h2>
                    <span class="help"><?php echo $text_rule_to_manufacturers_help; ?></span><br/>
                    <table class="form">
                        <?php if (version_compare(VERSION, '1.5.5.1') >= 0) { ?>
                            <tr>
                                <td><?php echo $entry_manufacturers; ?></td>
                                <td><input type="text" name="rule_manufacturers" value="" /></td>
                            </tr>
                            <tr>
                                <td>&nbsp;</td>
                                <td>
                                    <div class="scrollbox" id="rule_manufacturer">
                                        <?php $class = 'odd'; ?>
                                        <?php foreach ($rule_manufacturers as $rule_manufacturer) { ?>
                                            <?php $class = ($class == 'even' ? 'odd' : 'even'); ?>
                                            <div id="rule_manufacturer<?php echo $rule_manufacturer['manufacturer_id']; ?>" class="<?php echo $class; ?>">
                                                <?php echo $rule_manufacturer['name']; ?><img src="view/image/delete.png" />
                                                <input type="hidden" name="rule_manufacturer[]" value="<?php echo $rule_manufacturer['manufacturer_id']; ?>" />
                                            </div>
                                        <?php } ?>
                                    </div>
                                </td>
                            </tr>
                        <?php } else { ?>
                            <tr>
                                <td><?php echo $entry_manufacturers; ?></td>
                                <td>
                                    <div class="scrollbox">
                                        <?php $class = 'odd'; ?>
                                        <?php foreach ($manufacturers as $manufacturer) { ?>
                                            <?php $class = ($class == 'even' ? 'odd' : 'even'); ?>
                                            <div class="<?php echo $class; ?>">
                                                <?php if ($rule_manufacturers && is_array($rule_manufacturers) && in_array($manufacturer['manufacturer_id'], $rule_manufacturers)) { ?>
                                                    <input type="checkbox" name="rule_manufacturer[]" value="<?php echo $manufacturer['manufacturer_id']; ?>" checked="checked" />
                                                <?php } else { ?>
                                                    <input type="checkbox" name="rule_manufacturer[]" value="<?php echo $manufacturer['manufacturer_id']; ?>" />
                                                <?php } ?>
                                                <?php echo $manufacturer['name']; ?>
                                            </div>
                                        <?php } ?>
                                    </div>
                                </td>
                            </tr>
                        <?php } ?>
                    </table>
                    <h2><?php echo $text_rule_to_conditions; ?></h2>
                    <span class="help"><?php echo $text_rule_to_product_help; ?></span><br/>
                    <table class="form">
                        <tr>
                            <td><?php echo $entry_skip_special; ?></td>
                            <td>
                                <?php if ($skip_special) {
                                    $checked1 = ' checked="checked"';
                                    $checked0 = '';
                                } else {
                                    $checked1 = '';
                                    $checked0 = ' checked="checked"';
                                } ?>
                                <label for="skip_special_1">
                                    <?php echo $text_yes; ?>
                                    <input type="radio"<?php echo $checked1; ?> id="skip_special_1" name="skip_special" value="1" />
                                </label>
                                <label for="skip_special_0">
                                    <?php echo $text_no; ?>
                                    <input type="radio"<?php echo $checked0; ?> id="skip_special_0" name="skip_special" value="0" />
                                </label>
                            </td>
                        </tr>
                    </table>
                    <table class="form">
                        <tr>
                            <td>
                                <?php
                                    function actionsTree($actions, $scope, $key = '') {

                                        if (!$key) {
                                            $out = '<div class="rule">';
                                        } elseif ($key == '1--') {
                                            $out = '<ul class="rules" data-section="actions">';
                                        } else {
                                            $out = '<ul class="rules">';
                                        }

                                        foreach($actions as $i => $action) {
                                            $k = $key . ($i + 1);

                                            if ($key) {
                                                $out .= '<li>';
                                            }

                                            $out .= '<input type="hidden" name="rule[actions][' . $k . '][type]" value="' . $action['type'] . '" />';

                                            switch ($action['type']) {
                                                case 'rule/condition_combine':
                                                    $out .= sprintf($scope['rule_condition_combine'], '<span class="data-edit" data-type="select" data-values="all_any" data-selected="' . $action['aggregator'] . '" data-name="rule[actions][' . $k . '][aggregator]"></span>', '<span class="data-edit" data-type="select" data-values="true_false" data-selected="' . $action['value'] . '" data-name="rule[actions][' . $k . '][value]"></span>');
                                                break;
                                                case 'rule/condition_product|manufacturer_id':
                                                    $out .= sprintf($scope['rule_condition_manufacturer_id'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $action['operator'] . '" data-name="rule[actions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="select" data-values="manufacturers" data-name="rule[actions][' . $k . '][value]" data-selected="' . $action['value'] . '"></span>');
                                                break;
                                                case 'rule/condition_product|category_id':
                                                    $out .= sprintf($scope['rule_condition_category_id'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $action['operator'] . '" data-name="rule[actions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="select" data-values="categories" data-name="rule[actions][' . $k . '][value]" data-selected="' . $action['value'] . '"></span>');
                                                break;
                                                case 'rule/condition_product|price_type':
                                                    $out .= sprintf($scope['rule_condition_price_type'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $action['operator'] . '" data-name="rule[actions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="select" data-values="price_types" data-name="rule[actions][' . $k . '][value]" data-selected="' . $action['value'] . '"></span>');
                                                break;
                                                case 'rule/condition_product|model':
                                                    $out .= sprintf($scope['rule_condition_model'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $action['operator'] . '" data-name="rule[actions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[actions][' . $k . '][value]" data-selected="' . $action['value'] . '">' . ($action['value'] ? $action['value'] : '&hellip;') . '</span>');
                                                break;
                                            }

                                            if (strpos($action['type'], 'rule/condition_product|attribute_') === 0) {
                                                $out .= $scope['values_product_conditions_page'][$action['type']] . ' <span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $action['operator'] . '" data-name="rule[actions][' . $k . '][operator]"></span> <span class="data-edit" data-type="text" data-name="rule[actions][' . $k . '][value]" data-selected="' . $action['value'] . '">' . ($action['value'] ? $action['value'] : '&hellip;') . '</span>';
                                            }

                                            if (strpos($action['type'], 'rule/condition_product|option_') === 0) {
                                                $out .= $scope['values_product_conditions_page'][$action['type']] . ' <span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $action['operator'] . '" data-name="rule[actions][' . $k . '][operator]"></span> ';
                                                if (substr($action['type'], -strlen('select')) === 'select' || substr($action['type'], -strlen('radio')) === 'radio' || substr($action['type'], -strlen('checkbox')) === 'checkbox' || substr($action['type'], -strlen('image')) === 'image') {
                                                    $arr = explode('|', str_replace('rule/condition_product|option_', '', $action['type']));
                                                    $out .= '<span class="data-edit" data-type="select" data-values="options_values_' . array_shift($arr) . '" data-selected="' . $action['value'] . '" data-name="rule[actions][' . $k . '][value]"></span>';
                                                } elseif (substr($action['type'], -strlen('text')) === 'text') {
                                                    $out .= '<span class="data-edit" data-type="text" data-name="rule[actions][' . $k . '][value]" data-selected="' . $action['value'] . '">' . ($action['value'] ? $action['value'] : '&hellip;') . '</span>';
                                                } elseif (substr($action['type'], -strlen('textarea')) === 'textarea') {
                                                    $out .= '<span class="data-edit" data-type="textarea" data-name="rule[actions][' . $k . '][value]">' . ($action['value'] ? $action['value'] : '&hellip;') . '</span>';
                                                } elseif (substr($action['type'], -strlen('datetime')) === 'datetime') {
                                                    $out .= '<span class="data-edit" data-type="text" data-name="rule[actions][' . $k . '][value]" data-class="datetime" data-selected="' . $action['value'] . '">' . ($action['value'] ? $action['value'] : '&hellip;') . '</span>';
                                                } elseif (substr($action['type'], -strlen('date')) === 'date') {
                                                    $out .= '<span class="data-edit" data-type="text" data-name="rule[actions][' . $k . '][value]" data-class="date" data-selected="' . $action['value'] . '">' . ($action['value'] ? $action['value'] : '&hellip;') . '</span>';
                                                } elseif (substr($action['type'], -strlen('time')) === 'time') {
                                                    $out .= '<span class="data-edit" data-type="text" data-name="rule[actions][' . $k . '][value]" data-class="time" data-selected="' . $action['value'] . '">' . ($action['value'] ? $action['value'] : '&hellip;') . '</span>';
                                                }
                                            }

                                            if (!$key) {
                                                $out .= '</div>';
                                            } else {
                                                $out .= '<img class="remove-rule" src="view/image/delete.png" alt="" valign="middle" />';
                                            }

                                            if (!empty($action['rules'])) {
                                                $out .= actionsTree($action['rules'], $scope, $k . '--');
                                            } elseif (!$key) {
                                                $out .= '<ul class="rules" data-section="actions">';
                                                $out .= '<li><span class="data-edit" data-rule="new" data-type="select" data-values="product_conditions_page"><img class="add-rule" src="view/image/add.png" alt="" valign="middle" /></span></li>';
                                                $out .= '</ul>';
                                            }

                                            if ($key) {
                                                $out.= '</li>';
                                            }
                                        }

                                        if ($key) {
                                            $out .= '<li><span class="data-edit" data-rule="new" data-type="select" data-values="product_conditions_page"><img class="add-rule" src="view/image/add.png" alt="" valign="middle" /></span></li>';

                                            $out .= '</ul>';
                                        }

                                        return $out;
                                    }

                                    if (empty($rule['actions'])) {
                                        $rule['actions'] = array(array('type' => 'rule/condition_combine', 'aggregator' => 'all', 'value' => '1'));
                                    }

                                    echo actionsTree($rule['actions'], $this->data);
                                ?>
                            </td>
                        </tr>
                    </table>
                </div>
            </form>
        </div>
        <p style="text-align:center; color:#222;">Special Promotions OpenCart Module v<?php echo $version; ?> - <a href="http://exife.com" target="_blank">exife.com</a></p>
    </div>
</div>
<script type="text/javascript"><!--
    var position_row = <?php echo $position_row; ?>;

    function addPosition() {
        html  = '<tbody id="position-row' + position_row + '">';
        html += '  <tr>';
        html += '    <td class="left"><select name="position[' + position_row + '][layout_id]">';
        <?php foreach ($layouts as $layout) { ?>
        html += '      <option value="<?php echo $layout['layout_id']; ?>"><?php echo addslashes($layout['name']); ?></option>';
        <?php } ?>
        html += '    </select></td>';
        html += '    <td class="left"><select name="position[' + position_row + '][position]">';
        html += '      <option value="content_top"><?php echo $text_content_top; ?></option>';
        html += '      <option value="content_bottom"><?php echo $text_content_bottom; ?></option>';
        html += '      <option value="column_left"><?php echo $text_column_left; ?></option>';
        html += '      <option value="column_right"><?php echo $text_column_right; ?></option>';
        html += '    </select></td>';
        html += '    <td class="left"><select name="position[' + position_row + '][status]">';
        html += '      <option value="1" selected="selected"><?php echo $text_enabled; ?></option>';
        html += '      <option value="0"><?php echo $text_disabled; ?></option>';
        html += '    </select></td>';
        html += '    <td class="right"><input type="text" name="position[' + position_row + '][sort_order]" value="" size="3" /></td>';
        html += '    <td class="left"><a onclick="$(\'#position-row' + position_row + '\').remove();" class="button"><span><?php echo $button_remove; ?></span></a></td>';
        html += '  </tr>';
        html += '</tbody>';

        $('#position tfoot').before(html);

        position_row++;
}
//--></script>
<script type="text/javascript"><!--
    var select_options = {
        all_any: $.parseJSON('<?php echo addslashes(json_encode($values_all_any)); ?>'),
        true_false: $.parseJSON('<?php echo addslashes(json_encode($values_true_false)); ?>'),
        conditions: $.parseJSON('<?php echo addslashes(json_encode($values_conditions)); ?>'),
        product_conditions: $.parseJSON('<?php echo addslashes(json_encode($values_product_conditions)); ?>'),
        product_conditions_page: $.parseJSON('<?php echo addslashes(json_encode($values_product_conditions_page)); ?>'),
        found_not_found: $.parseJSON('<?php echo addslashes(json_encode($values_found_not_found)); ?>'),
        total_qty_amount: $.parseJSON('<?php echo addslashes(json_encode($values_total_qty_amount)); ?>'),
        operators: $.parseJSON('<?php echo addslashes(json_encode($values_operator)); ?>'),
        is_is_not: $.parseJSON('<?php echo addslashes(json_encode($values_is_is_not)); ?>'),
        weekdays: $.parseJSON('<?php echo addslashes(json_encode($values_weekdays)); ?>'),
        price_types: $.parseJSON('<?php echo addslashes(json_encode($values_price_types)); ?>'),
        payment_methods: $.parseJSON('<?php echo addslashes(json_encode($values_payment_methods)); ?>'),
        shipping_methods: $.parseJSON('<?php echo addslashes(json_encode($values_shipping_methods)); ?>'),
        countries: $.parseJSON('<?php echo addslashes(json_encode($values_countries)); ?>'),
        zones: $.parseJSON('<?php echo addslashes(json_encode($values_zones)); ?>'),
        stores: $.parseJSON('<?php echo addslashes(json_encode($values_stores)); ?>'),
        customer_groups: $.parseJSON('<?php echo addslashes(json_encode($values_customer_groups)); ?>'),
        manufacturers: $.parseJSON('<?php echo addslashes(json_encode($values_manufacturers)); ?>'),
        categories: $.parseJSON('<?php echo addslashes(json_encode($values_categories)); ?>'),
        <?php $i = 0; foreach($values_options_values as $option_id => $options_values) { ?>
        options_values_<?php echo $option_id; ?>: $.parseJSON('<?php echo addslashes(json_encode($options_values)); ?>')<?php if ($i < (count($values_options_values) - 1)) { ?>,<?php } ?>
        <?php $i++; } $i = 0; ?>
    }

    if (typeof String.prototype.startsWith != 'function') {
        String.prototype.startsWith = function (str){
            return this.slice(0, str.length) == str;
        };
    }
    if (typeof String.prototype.endsWith != 'function') {
        String.prototype.endsWith = function (str){
            return this.slice(-str.length) == str;
        };
    }
//--></script>
<script type="text/javascript" src="view/javascript/ckeditor/ckeditor.js"></script>
<script type="text/javascript"><!--
<?php $banner_row = 1; ?>
<?php foreach ($banners as $banner) { ?>
    <?php foreach ($languages as $language) { ?>
        CKEDITOR.replace('content-<?php echo $banner_row; ?>-<?php echo $language['language_id']; ?>', {
            filebrowserBrowseUrl: 'index.php?route=common/filemanager&token=<?php echo $token; ?>',
            filebrowserImageBrowseUrl: 'index.php?route=common/filemanager&token=<?php echo $token; ?>',
            filebrowserFlashBrowseUrl: 'index.php?route=common/filemanager&token=<?php echo $token; ?>',
            filebrowserUploadUrl: 'index.php?route=common/filemanager&token=<?php echo $token; ?>',
            filebrowserImageUploadUrl: 'index.php?route=common/filemanager&token=<?php echo $token; ?>',
            filebrowserFlashUploadUrl: 'index.php?route=common/filemanager&token=<?php echo $token; ?>'
        });
    <?php } ?>
    <?php $banner_row++; ?>
<?php } ?>
//--></script>
<script type="text/javascript" src="view/javascript/jquery/ui/jquery-ui-timepicker-addon.js"></script>
<script type="text/javascript"><!--
    $(document).ready(function() {

        $('select[name=\'banner_type\']').change(function() {
            $('.banner-vtabs a:first').trigger('click');
            if ($(this).val() == 1) {
                $('.content-block').hide();
                $('.modal-popup').show();
                $('.content-block-margin').removeClass('vtabs-content');
            } else {
                $('.content-block').show();
                $('.modal-popup').hide();
                $('.content-block-margin').addClass('vtabs-content');
            }
        });

        if ($('select[name=\'banner_type\']').val() == 1) {
            $('select[name=\'banner_type\']').trigger('change');
        }

        $('.main-vtabs a').tabs();
        $('.banner-vtabs a').tabs();
        $('.htabs a').tabs();

        $('.banner-vtabs a').bind('click', function(){
            $($(this).attr('href') + ' .htabs a:first').trigger('click');
        });

        $('.date').datepicker({dateFormat: 'yy-mm-dd'});

        $('.datetime').datetimepicker({
            dateFormat: 'yy-mm-dd',
            timeFormat: 'hh:mm'
        });

        $('.time').timepicker({timeFormat: 'hh:mm'});

        $('.data-edit select').live('change', function() {
            $(this).blur();
        });

        $('.remove-rule').live('click', function() {
            $(this).parent().remove();
        });

        $('.warning, .success').live('click', function() {
           $(this).remove();
        });

        <?php $banner_row = 1; ?>
        <?php foreach ($banners as $banner) { ?>
            $('#language-<?php echo $banner_row; ?> a').tabs();

            $('input.banner_<?php echo $banner_row; ?>_products_in_banner').bind('click', function(){
                if ($('input.banner_<?php echo $banner_row; ?>_products_in_banner:checked').val() == 1) {
                   $('#products_in_banner<?php echo $banner_row; ?>').show();
                } else {
                   $('#products_in_banner<?php echo $banner_row; ?>').hide();
                }
            });

            $('input.banner_<?php echo $banner_row; ?>_products_in_banner:checked').trigger('click');

            // Products
            $('input[name=products<?php echo $banner_row; ?>]').autocomplete({
                delay: 0,
                source: function(request, response) {
                    $.ajax({
                        url: 'index.php?route=catalog/product/autocomplete&token=<?php echo $token; ?>&filter_name=' +  encodeURIComponent(request.term),
                        dataType: 'json',
                        data: {token: '<?php echo $token; ?>', filter_name: encodeURIComponent(request.term)},
                        type: 'POST',
                        success: function(json) {
                            response($.map(json, function(item) {
                                return {
                                    label: item.name,
                                    value: item.product_id
                                }
                            }));
                        }
                    });
                },
                select: function(event, ui) {
                    $('#product<?php echo $banner_row; ?>_' + ui.item.value).remove();

                    $('#product-<?php echo $banner_row; ?>').append('<div id="product<?php echo $banner_row; ?>_' + ui.item.value + '">' + ui.item.label + '<img src="view/image/delete.png" /><input type="hidden" name="banner[<?php echo $banner_row; ?>][product][]" value="' + ui.item.value + '" /></div>');

                    $('#product-<?php echo $banner_row; ?> div:odd').attr('class', 'odd');
                    $('#product-<?php echo $banner_row; ?> div:even').attr('class', 'even');

                    return false;
                }
            });

            $('#product-<?php echo $banner_row; ?> div img').live('click', function() {
                $(this).parent().remove();

                $('#product-<?php echo $banner_row; ?> div:odd').attr('class', 'odd');
                $('#product-<?php echo $banner_row; ?> div:even').attr('class', 'even');
            });

            <?php $banner_row++; ?>
        <?php } ?>

        setTimeout(function() {
            $('.banner-vtabs a:first').trigger('click');
        }, 1000);
    });
//--></script>
<script type="text/javascript"><!--
    function refresh_edit() {
        $('.data-edit').each(function(i) {
            var _holder = this;
            $.data(_holder, 'editable.type', $(_holder).attr('data-type'));
            !$.data(_holder, 'editable.options') && $(_holder).editable({
                type: $(_holder).attr('data-type'),
                name: $(_holder).attr('data-name'),
                editClass: $(_holder).attr('data-class'),
                options: select_options[$(_holder).attr('data-values')],
                submit: ($(_holder).attr('data-class') == 'date' || $(_holder).attr('data-class') == 'time' || $(_holder).attr('data-class') == 'datetime') ? '&nbsp;<img src="view/image/success.png" alt="" valign="middle" />' : null,
                onEdit: function(content) {
                    if ($(_holder).attr('data-type') == 'text') {
                        var _input = $(_holder).find('input');

                        if (content.current == '…') {
                            _input.val('');
                        }

                        if ($(_holder).attr('data-class') == 'date') {
                            _input.datepicker({dateFormat: 'yy-mm-dd'}).datepicker('show');
                        }

                        if ($(_holder).attr('data-class') == 'time') {
                            _input.timepicker({timeFormat: 'hh:mm'}).timepicker('show');
                        }

                        if ($(_holder).attr('data-class') == 'datetime') {
                            _input.datetimepicker({dateFormat: 'yy-mm-dd', timeFormat: 'hh:mm'}).datetimepicker('show');
                        }
                    }

                    if ($(_holder).attr('data-type') == 'textarea' && content.current == '…') {
                        $(_holder).find('textarea').val('');
                    }
                },
                onSubmit: function(content) {
                    if ($.data(_holder, 'editable.type') != 'select') {
                        if (content.current && content.current != '&hellip;') {
                            $(_holder).next().val(content.current);
                        } else {
                            $(_holder).next().val('');
                            $(_holder).html('&hellip;');
                        }
                    } else {
                        $(_holder).attr('data-selected', content.current_val);
                        $(_holder).next().val(content.current_val);
                    }
                    if ($.data(_holder, 'editable.type') == 'select' && $(_holder).attr('data-rule') == 'new') {
                        var id = $(_holder).parent().index() + 1,
                            holder_list = $(_holder).parent().parent(),
                            parents, section, product_conditions;

                        parents = holder_list.parentsUntil('td', 'li');
                        $.each(parents, function(index, item) {
                            id = ($(item).index() + 1) + '--' + id;
                        });

                        id = '1--' + id;

                        $(_holder).editable('destroy');

                        section = $(_holder).parents('ul.rules').last().attr('data-section');

                        product_conditions = $(_holder).parents('ul[data-section="actions"]').length > 0 || $(_holder).attr('data-values') == 'product_conditions';

                        if (content.current_val) {
                            $(_holder).parent().replaceWith(get_part(content.current_val, id, section, product_conditions));
                            holder_list.append(get_part('rule/new', 0, section, product_conditions));
                        } else {
                            $(_holder).parent().replaceWith(get_part('rule/new', 0, section, product_conditions));
                        }
                    }

                    refresh_edit();
                }
            });
        });
    }
    refresh_edit();

    function get_part(type, id, section, product_conditions) {
        if (type == 'add') {
            return '<span class="data-edit" data-rule="new" data-type="select" data-values="' + (product_conditions ? (section == 'actions' ? 'product_conditions_page' : 'product_conditions') : 'conditions') + '"><img class="add-rule" src="view/image/add.png" alt="" valign="middle" /></span>';
        } else if (type == 'remove') {
            return '<img class="remove-rule" src="view/image/delete.png" alt="" valign="middle" />';
        }

        var html = '';
        html += '<li>';

        if (id) {
            html += '<input type="hidden" name="rule[' + section + '][' + id + '][type]" value="' + type + '"/>';
        }

        switch (type) {
            case 'rule/new':
                html += get_part('add', 0, section, product_conditions);
                break;
            case 'rule/condition_product_found':
                html += '<?php echo sprintf($rule_condition_product_found, '<span class="data-edit" data-type="select" data-values="found_not_found" data-selected="1" data-name="rule[{section}][{id}][value]"></span>', '<span class="data-edit" data-type="select" data-values="all_any" data-selected="all" data-name="rule[{section}][{id}][aggregator]"></span>') ?>';
                break;
            case 'rule/condition_product_subselect':
                html += '<?php echo sprintf($rule_condition_product_subselect, '<span class="data-edit" data-type="select" data-values="total_qty_amount" data-selected="qty" data-name="rule[{section}][{id}][attribute]"></span>', '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>', '<span class="data-edit" data-type="select" data-values="all_any" data-selected="all" data-name="rule[{section}][{id}][aggregator]"></span>') ?>';
                break;
            case 'rule/condition_combine':
                html += '<?php echo sprintf($rule_condition_combine, '<span class="data-edit" data-type="select" data-values="all_any" data-selected="all" data-name="rule[{section}][{id}][aggregator]"></span>', '<span class="data-edit" data-type="select" data-values="true_false" data-selected="1" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_cart|base_subtotal':
                html += '<?php echo sprintf($rule_condition_cart_base_subtotal, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_cart|total_qty':
                html += '<?php echo sprintf($rule_condition_cart_total_qty, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_cart|diff_qty':
                html += '<?php echo sprintf($rule_condition_cart_diff_qty, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_cart|weight':
                html += '<?php echo sprintf($rule_condition_cart_weight, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_cart|payment_method':
                html += '<?php echo sprintf($rule_condition_cart_payment_method, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="payment_methods" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_cart|shipping_method':
                html += '<?php echo sprintf($rule_condition_cart_shipping_method, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="shipping_methods" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_cart|shipping_postcode':
                html += '<?php echo sprintf($rule_condition_cart_shipping_postcode, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_cart|shipping_zone_id':
                html += '<?php echo sprintf($rule_condition_cart_shipping_zone_id, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="zones" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_cart|shipping_country_id':
                html += '<?php echo sprintf($rule_condition_cart_shipping_country_id, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="countries" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_customer|store_id':
                html += '<?php echo sprintf($rule_condition_customer_store_id, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="stores" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_customer|customer_group_id':
                html += '<?php echo sprintf($rule_condition_customer_group_id, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="customer_groups" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_customer|registration_date':
                html += '<?php echo sprintf($rule_condition_customer_registration_date, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]" data-class="date">&hellip;</span>') ?>';
                break;
            case 'rule/condition_customer|email':
                html += '<?php echo sprintf($rule_condition_customer_email, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_customer|firstname':
                html += '<?php echo sprintf($rule_condition_customer_firstname, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_customer|lastname':
                html += '<?php echo sprintf($rule_condition_customer_lastname, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_orders|order_num':
                html += '<?php echo sprintf($rule_condition_orders_order_num, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_orders|sales_amount':
                html += '<?php echo sprintf($rule_condition_orders_sales_amount, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_orders|day_of_week':
                html += '<?php echo sprintf($rule_condition_day_of_week, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="weekdays" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_orders|time':
                html += '<?php echo sprintf($rule_condition_time, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]" data-class="time">&hellip;</span>') ?>';
                break;
            case 'rule/condition_cart_product|price':
                html += '<?php echo sprintf($rule_condition_cart_product_price, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_cart_product|qty':
                html += '<?php echo sprintf($rule_condition_cart_product_qty, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_cart_product|total':
                html += '<?php echo sprintf($rule_condition_cart_product_total, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_product|manufacturer_id':
            case 'rule/condition_cart_product|manufacturer_id':
                html += '<?php echo sprintf($rule_condition_manufacturer_id, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="manufacturers" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_product|category_id':
            case 'rule/condition_cart_product|category_id':
                html += '<?php echo sprintf($rule_condition_category_id, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="categories" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_product|price_type':
            case 'rule/condition_cart_product|price_type':
                html += '<?php echo sprintf($rule_condition_price_type, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="price_types" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_product|model':
            case 'rule/condition_cart_product|model':
                html += '<?php echo sprintf($rule_condition_model, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
        }

        if (type.startsWith('rule/condition_cart_product|attribute_')) {
            html += select_options.product_conditions[type] + ' <span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span> <span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>';
        }

        if (type.startsWith('rule/condition_product|attribute_')) {
            html += select_options.product_conditions_page[type] + ' <span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span> <span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>';
        }

        if (type.startsWith('rule/condition_cart_product|option_')) {
            html += select_options.product_conditions[type] + ' <span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span> ';
            if (type.endsWith('select') || type.endsWith('radio') || type.endsWith('checkbox') || type.endsWith('image')) {
                html += '<span class="data-edit" data-type="select" data-values="options_values_' + type.replace('rule/condition_cart_product|option_', '').split('|').slice(0, 1) + '" data-selected="" data-name="rule[{section}][{id}][value]"></span>';
            } else if (type.endsWith('text')) {
                html += '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>';
            } else if (type.endsWith('textarea')) {
                html += '<span class="data-edit" data-type="textarea" data-name="rule[{section}][{id}][value]">&hellip;</span>';
            } else if (type.endsWith('datetime')) {
                html += '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]" data-class="datetime">&hellip;</span>';
            } else if (type.endsWith('date')) {
                html += '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]" data-class="date">&hellip;</span>';
            } else if (type.endsWith('time')) {
                html += '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]" data-class="time">&hellip;</span>';
            }
        }

        if (type.startsWith('rule/condition_product|option_')) {
            html += select_options.product_conditions_page[type] + ' <span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span> ';
            if (type.endsWith('select') || type.endsWith('radio') || type.endsWith('checkbox') || type.endsWith('image')) {
                html += '<span class="data-edit" data-type="select" data-values="options_values_' + type.replace('rule/condition_product|option_', '').split('|').slice(0, 1) + '" data-selected="" data-name="rule[{section}][{id}][value]"></span>';
            } else if (type.endsWith('text')) {
                html += '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>';
            } else if (type.endsWith('textarea')) {
                html += '<span class="data-edit" data-type="textarea" data-name="rule[{section}][{id}][value]">&hellip;</span>';
            } else if (type.endsWith('datetime')) {
                html += '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]" data-class="datetime">&hellip;</span>';
            } else if (type.endsWith('date')) {
                html += '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]" data-class="date">&hellip;</span>';
            } else if (type.endsWith('time')) {
                html += '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]" data-class="time">&hellip;</span>';
            }
        }

        if (type != 'rule/new') {
            html += get_part('remove');
        }

        if (type == 'rule/condition_product_found' || type == 'rule/condition_product_subselect' || (type == 'rule/condition_combine' && product_conditions)) {
            html += '<ul class="rules" data-section="actions">';
            html += get_part('rule/new', 0, section, true);
            html += '</ul>';
        } else if (type == 'rule/condition_combine') {
            html += '<ul class="rules">';
            html += get_part('rule/new', 0, section, (section == 'actions'));
            html += '</ul>';
        }

        html += '</li>';

        return html.replace(/\{section\}/g, section).replace(/\{id\}/g, id);
    }
//--></script>
<script type="text/javascript"><!--
    // Cart Products
    $('input[name=\'cart_products\']').autocomplete({
        delay: 0,
        source: function(request, response) {
            $.ajax({
                url: 'index.php?route=catalog/product/autocomplete&token=<?php echo $token; ?>&filter_name=' +  encodeURIComponent(request.term),
                dataType: 'json',
                data: {token: '<?php echo $token; ?>', filter_name: encodeURIComponent(request.term)},
                type: 'POST',
                success: function(json) {
                    response($.map(json, function(item) {
                        return {
                            label: item.name,
                            value: item.product_id
                        }
                    }));
                }
            });
        },
        select: function(event, ui) {
            $('#cart_product' + ui.item.value).remove();

            $('#cart_product').append('<div id="cart_product' + ui.item.value + '">' + ui.item.label + '<img src="view/image/delete.png" /><input type="hidden" name="cart_product[]" value="' + ui.item.value + '" /></div>');

            $('#cart_product div:odd').attr('class', 'odd');
            $('#cart_product div:even').attr('class', 'even');

            return false;
        }
    });

    $('#cart_product div img').live('click', function() {
        $(this).parent().remove();

        $('#cart_product div:odd').attr('class', 'odd');
        $('#cart_product div:even').attr('class', 'even');
    });

    // Rule Manufacturers
    $('input[name=\'rule_manufacturers\']').autocomplete({
        delay: 0,
        source: function(request, response) {
            $.ajax({
                url: 'index.php?route=catalog/manufacturer/autocomplete&token=<?php echo $token; ?>&filter_name=' +  encodeURIComponent(request.term),
                dataType: 'json',
                data: {token: '<?php echo $token; ?>', filter_name: encodeURIComponent(request.term)},
                type: 'POST',
                success: function(json) {
                    response($.map(json, function(item) {
                        return {
                            label: item.name,
                            value: item.manufacturer_id
                        }
                    }));
                }
            });
        },
        select: function(event, ui) {
            $('#rule_manufacturer' + ui.item.value).remove();

            $('#rule_manufacturer').append('<div id="rule_manufacturer' + ui.item.value + '">' + ui.item.label + '<img src="view/image/delete.png" alt="" /><input type="hidden" name="rule_manufacturer[]" value="' + ui.item.value + '" /></div>');

            $('#rule_manufacturer div:odd').attr('class', 'odd');
            $('#rule_manufacturer div:even').attr('class', 'even');

            return false;
        },
        focus: function(event, ui) {
          return false;
       }
    });

    // Rule Categories
    $('input[name=\'rule_categories\']').autocomplete({
        delay: 0,
        source: function(request, response) {
            $.ajax({
                url: 'index.php?route=catalog/category/autocomplete&token=<?php echo $token; ?>&filter_name=' +  encodeURIComponent(request.term),
                dataType: 'json',
                data: {token: '<?php echo $token; ?>', filter_name: encodeURIComponent(request.term)},
                type: 'POST',
                success: function(json) {
                    response($.map(json, function(item) {
                        return {
                            label: item.name,
                            value: item.category_id
                        }
                    }));
                }
            });
        },
        select: function(event, ui) {
            $('#rule_category' + ui.item.value).remove();

            $('#rule_category').append('<div id="rule_category' + ui.item.value + '">' + ui.item.label + '<img src="view/image/delete.png" alt="" /><input type="hidden" name="rule_category[]" value="' + ui.item.value + '" /></div>');

            $('#rule_category div:odd').attr('class', 'odd');
            $('#rule_category div:even').attr('class', 'even');

            return false;
        },
        focus: function(event, ui) {
          return false;
       }
    });

    $('#rule_category div img').live('click', function() {
        $(this).parent().remove();

        $('#rule_category div:odd').attr('class', 'odd');
        $('#rule_category div:even').attr('class', 'even');
    });

    // Rule Products
    $('input[name=\'rule_products\']').autocomplete({
        delay: 0,
        source: function(request, response) {
            $.ajax({
                url: 'index.php?route=catalog/product/autocomplete&token=<?php echo $token; ?>&filter_name=' +  encodeURIComponent(request.term),
                dataType: 'json',
                data: {token: '<?php echo $token; ?>', filter_name: encodeURIComponent(request.term)},
                type: 'POST',
                success: function(json) {
                    response($.map(json, function(item) {
                        return {
                            label: item.name,
                            value: item.product_id
                        }
                    }));
                }
            });
        },
        select: function(event, ui) {
            $('#rule_product' + ui.item.value).remove();

            $('#rule_product').append('<div id="rule_product' + ui.item.value + '">' + ui.item.label + '<img src="view/image/delete.png" /><input type="hidden" name="rule_product[]" value="' + ui.item.value + '" /></div>');

            $('#rule_product div:odd').attr('class', 'odd');
            $('#rule_product div:even').attr('class', 'even');

            return false;
        }
    });

    $('#rule_product div img').live('click', function() {
        $(this).parent().remove();

        $('#rule_product div:odd').attr('class', 'odd');
        $('#rule_product div:even').attr('class', 'even');
    });
//--></script>
<script type="text/javascript"><!--
    var banner_row = <?php echo $banner_row; ?>;

    function addBanner() {
        var html  = '<div id="tab-banner-' + banner_row + '" class="vtabs-content">';
        html += '    <div id="language-' + banner_row + '" class="htabs">';
        <?php foreach ($languages as $language) { ?>
        html += '       <a href="#tab-language-' + banner_row + '-<?php echo $language['language_id']; ?>"><img src="view/image/flags/<?php echo $language['image']; ?>" title="<?php echo $language['name']; ?>" /> <?php echo $language['name']; ?></a>';
        <?php } ?>
        html += '</div>';
        <?php foreach ($languages as $language) { ?>
        html += '<div id="tab-language-' + banner_row + '-<?php echo $language['language_id']; ?>">';
        html += '    <table class="form">';
        html += '        <tr>';
        html += '           <td><?php echo $entry_heading_text; ?></td>';
        html += '           <td>';
        html += '               <input type="text" name="banner[' + banner_row + '][heading_text][<?php echo $language['language_id']; ?>]" value="" size="100" />';
        html += '           </td>';
        html += '        </tr>';
        html += '        <tr>';
        html += '           <td><?php echo $entry_content; ?></td>';
        html += '           <td><textarea name="banner[' + banner_row + '][content][<?php echo $language['language_id']; ?>]" id="content-' + banner_row + '-<?php echo $language['language_id']; ?>"></textarea></td>';
        html += '        </tr>';
        html += '   </table>';
        html += '</div>';
        <?php } ?>
        html += '   <table class="form">';
        html += '       <tr>';
        html += '           <td><?php echo $entry_products_in_banner; ?></td>';
        html += '           <td>';
        html += '               <label for="products_in_banner_' + banner_row + '_1"><?php echo $text_yes; ?>';
        html += '               <input type="radio" id="products_in_banner_' + banner_row + '_1" name="banner[' + banner_row + '][products_in_banner]" class="banner_' + banner_row + '_products_in_banner" value="1" /></label>';
        html += '               <label for="products_in_banner_' + banner_row + '_0"><?php echo $text_no; ?>';
        html += '               <input type="radio" checked="checked" id="products_in_banner_' + banner_row + '_0" name="banner[' + banner_row + '][products_in_banner]" class="banner_' + banner_row + '_products_in_banner" value="0" /></label>';
        html += '           </td>';
        html += '       </tr>';
        html += '       <tbody id="products_in_banner' + banner_row + '">';
        html += '           <tr>';
        html += '               <td><?php echo $entry_products; ?></td>';
        html += '               <td><input type="text" name="products' + banner_row + '" value="" /></td>';
        html += '           </tr>';
        html += '           <tr>';
        html += '               <td>&nbsp;</td>';
        html += '               <td>';
        html += '                   <div class="scrollbox" id="product-' + banner_row + '"></div>';
        html += '               </td>';
        html += '           </tr>';
        html += '           <tr>';
        html += '               <td><?php echo $entry_image_size; ?></td>';
        html += '               <td>';
        html += '                   <input type="text" name="banner[' + banner_row + '][image_width]" value="<?php echo $this->config->get('config_image_product_width'); ?>" size="3" /> &times; <input type="text" name="banner[' + banner_row + '][image_height]" value="<?php echo $this->config->get('config_image_product_height'); ?>" size="3" />';
        html += '               </td>';
        html += '           </tr>';
        html += '       </tbody>';
        html += '       <tr>';
        html += '           <td><?php echo $entry_show_boxframe; ?></td>';
        html += '           <td>';
        html += '               <label for="show_boxframe_' + banner_row + '_1"><?php echo $text_yes; ?>';
        html += '               <input type="radio" id="show_boxframe_' + banner_row + '_1" name="banner[' + banner_row + '][show_boxframe]" value="1" /></label>';
        html += '               <label for="show_boxframe_' + banner_row + '_0"><?php echo $text_no; ?>';
        html += '               <input type="radio" checked="checked" id="show_boxframe_' + banner_row + '_0" name="banner[' + banner_row + '][show_boxframe]" value="0" /></label>';
        html += '           </td>';
        html += '       </tr>';
        html += '   </table>';
        html += '</div>';

        $('#tab-position-content').append(html);

        <?php foreach ($languages as $language) { ?>
            CKEDITOR.replace('content-' + banner_row + '-<?php echo $language['language_id']; ?>', {
                filebrowserBrowseUrl: 'index.php?route=common/filemanager&token=<?php echo $token; ?>',
                filebrowserImageBrowseUrl: 'index.php?route=common/filemanager&token=<?php echo $token; ?>',
                filebrowserFlashBrowseUrl: 'index.php?route=common/filemanager&token=<?php echo $token; ?>',
                filebrowserUploadUrl: 'index.php?route=common/filemanager&token=<?php echo $token; ?>',
                filebrowserImageUploadUrl: 'index.php?route=common/filemanager&token=<?php echo $token; ?>',
                filebrowserFlashUploadUrl: 'index.php?route=common/filemanager&token=<?php echo $token; ?>'
            });
        <?php } ?>

        $('#language-' + banner_row + ' a').tabs();

        $('input.banner_' + banner_row + '_products_in_banner').data( "row", banner_row);
        $('input.banner_' + banner_row + '_products_in_banner').bind('click', function(){
            if ($('input.banner_' + $(this).data('row') + '_products_in_banner:checked').val() == 1) {
               $('#products_in_banner' + $(this).data('row')).show();
            } else {
               $('#products_in_banner' + $(this).data('row')).hide();
            }
        });

        $('input.banner_' + banner_row + '_products_in_banner:checked').trigger('click');

        // Products
        $('input[name=products' + banner_row + ']').data('row', banner_row);
        $('input[name=products' + banner_row + ']').autocomplete({
            delay: 0,
            source: function(request, response) {
                $.ajax({
                    url: 'index.php?route=catalog/product/autocomplete&token=<?php echo $token; ?>&filter_name=' +  encodeURIComponent(request.term),
                    dataType: 'json',
                    data: {token: '<?php echo $token; ?>', filter_name: encodeURIComponent(request.term)},
                    type: 'POST',
                    success: function(json) {
                        response($.map(json, function(item) {
                            return {
                                label: item.name,
                                value: item.product_id
                            }
                        }));
                    }
                });
            },
            select: function(event, ui) {
                $('#product' + $(this).data('row') + '_' + ui.item.value).remove();

                $('#product-' + $(this).data('row')).append('<div id="product' + $(this).data('row') + '_' + ui.item.value + '">' + ui.item.label + '<img src="view/image/delete.png" /><input type="hidden" name="banner[' + $(this).data('row') + '][product][]" value="' + ui.item.value + '" /></div>');

                $('#product-' + $(this).data('row') + ' div:odd').attr('class', 'odd');
                $('#product-' + $(this).data('row') + ' div:even').attr('class', 'even');

                return false;
            }
        });

        $('#product-' + banner_row).data('row', banner_row);
        $('#product-' + banner_row + ' div img').live('click', function() {
            var row = $(this).parent().parent().data('row');
            $(this).parent().remove();

            $('#product-' + row + ' div:odd').attr('class', 'odd');
            $('#product-' + row + ' div:even').attr('class', 'even');
        });

        $('#banner-add').before('<a href="#tab-banner-' + banner_row + '" id="banner-' + banner_row + '"><?php echo $tab_banner; ?> ' + banner_row + '&nbsp;<img src="view/image/delete.png" alt="" onclick="$(\'.banner-vtabs a:first\').trigger(\'click\'); $(\'#banner-' + banner_row + '\').remove(); $(\'#tab-banner-' + banner_row + '\').remove(); return false;" /></a>');

        $('.banner-vtabs a').tabs();

        $('.banner-vtabs a').bind('click', function(){
            $($(this).attr('href') + ' .htabs a:first').trigger('click');
        });

        $('#banner-' + banner_row).trigger('click');

        banner_row++;
    }
//--></script>
<?php echo $footer; ?>